Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3382)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3418)
@@ -613,4 +906,35 @@
        REAL(wp), DIMENSION(:,:), ALLOCATABLE       :: t
     END TYPE t_wall_vertical
+
+    TYPE surf_type_usm
+       REAL(wp), DIMENSION(:),   ALLOCATABLE ::  var_usm_1d !< 1D prognostic variable
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  var_usm_2d !< 2D prognostic variable
+    END TYPE surf_type_usm
+    
+#if defined( __nopointer )
+    TYPE(surf_type_usm), TARGET   ::  m_liq_usm_h,        & !< liquid water reservoir (m), horizontal surface elements 
+                                      m_liq_usm_h_p         !< progn. liquid water reservoir (m), horizontal surface elements 
+
+    TYPE(surf_type_usm), DIMENSION(0:3), TARGET   ::  &
+                                      m_liq_usm_v,        & !< liquid water reservoir (m), vertical surface elements 
+                                      m_liq_usm_v_p         !< progn. liquid water reservoir (m), vertical surface elements 
+#else
+    TYPE(surf_type_usm), POINTER  ::  m_liq_usm_h,        & !< liquid water reservoir (m), horizontal surface elements 
+                                      m_liq_usm_h_p         !< progn. liquid water reservoir (m), horizontal surface elements 
+
+    TYPE(surf_type_usm), TARGET   ::  m_liq_usm_h_1,      & !<
+                                      m_liq_usm_h_2         !<
+
+    TYPE(surf_type_usm), DIMENSION(:), POINTER  ::    &
+                                      m_liq_usm_v,        & !< liquid water reservoir (m), vertical surface elements 
+                                      m_liq_usm_v_p         !< progn. liquid water reservoir (m), vertical surface elements 
+
+    TYPE(surf_type_usm), DIMENSION(0:3), TARGET   ::  &
+                                      m_liq_usm_v_1,      & !<
+                                      m_liq_usm_v_2         !<
+#endif
+
+    TYPE(surf_type_usm), TARGET ::  tm_liq_usm_h_m      !< liquid water reservoir tendency (m), horizontal surface elements 
+    TYPE(surf_type_usm), DIMENSION(0:3), TARGET ::  tm_liq_usm_v_m      !< liquid water reservoir tendency (m), vertical surface elements 
 
 
@@ -633,4 +957,16 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinswdif_av    !< Average of pcbinswdif
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinswref_av    !< Average of pcbinswref
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfhf_av        !< average of total radiation flux incoming to minus outgoing from local surface  
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  wghf_eb_av       !< average of wghf_eb
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  wshf_eb_av       !< average of wshf_eb
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  t_wall_av        !< Average of t_wall
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  wghf_eb_green_av !< average of wghf_eb_green
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  t_green_av       !< Average of t_green
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  wghf_eb_window_av !< average of wghf_eb_window
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  t_window_av      !< Average of t_window
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  qsws_eb_av       !< average of qsws_eb
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  qsws_veg_eb_av   !< average of qsws_veg_eb
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  qsws_liq_eb_av   !< average of qsws_liq_eb
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  swc_av        !< Average of swc
     
 
@@ -668,4 +1004,7 @@
     REAL(wp)                                       :: window_inner_temperature = 295.0_wp  !< temperature of the inner window surface (~22 degrees C) (K)
 
+        REAL(wp)                                       ::   m_total = 0.0_wp !< weighted total water content of the soil (m3/m3)
+    INTEGER(iwp)                                   ::   soil_type
+    
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !-- surface and material model variables for walls, ground, roofs
@@ -676,6 +1015,6 @@
 
 #if defined( __nopointer )
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_h           !< wall surface temperature (K) at horizontal walls
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_h_p         !< progn. wall surface temperature (K) at horizontal walls
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_wall_h           !< wall surface temperature (K) at horizontal walls
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_wall_h_p         !< progn. wall surface temperature (K) at horizontal walls
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_window_h    !< window surface temperature (K) at horizontal walls
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_window_h_p  !< progn. window surface temperature (K) at horizontal walls
@@ -684,6 +1023,6 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_10cm_h      !< near surface temperature (10cm) (K) at horizontal walls
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_10cm_h_p    !< progn. near surface temperature (10cm) (K) at horizontal walls
-    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_v
-    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_v_p
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_wall_v
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_wall_v_p
     TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_window_v
     TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_window_v_p
@@ -693,6 +1032,6 @@
     TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_10cm_v_p
 #else
-    REAL(wp), DIMENSION(:), POINTER                :: t_surf_h
-    REAL(wp), DIMENSION(:), POINTER                :: t_surf_h_p 
+    REAL(wp), DIMENSION(:), POINTER                :: t_surf_wall_h
+    REAL(wp), DIMENSION(:), POINTER                :: t_surf_wall_h_p 
     REAL(wp), DIMENSION(:), POINTER                :: t_surf_window_h
     REAL(wp), DIMENSION(:), POINTER                :: t_surf_window_h_p 
@@ -702,6 +1041,6 @@
     REAL(wp), DIMENSION(:), POINTER                :: t_surf_10cm_h_p
 
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_h_1
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_h_2
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_wall_h_1
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_wall_h_2
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_window_h_1
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_window_h_2
@@ -711,6 +1050,6 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_10cm_h_2
 
-    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_v
-    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_v_p
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_wall_v
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_wall_v_p
     TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_window_v
     TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_window_v_p
@@ -720,6 +1059,6 @@
     TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_10cm_v_p
 
-    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_v_1
-    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_v_2
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_wall_v_1
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_wall_v_2
     TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_window_v_1
     TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_window_v_2
@@ -730,4 +1069,13 @@
     
 #endif
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_wall_av          !< average of wall surface temperature (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_window_av   !< average of window surface temperature (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_green_av    !< average of green wall surface temperature (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_10cm_av    !< average of whole wall surface temperature (K)
+
+!-- Temporal tendencies for time stepping            
+    REAL(wp), DIMENSION(:), ALLOCATABLE            :: tt_surface_wall_m       !< surface temperature tendency of wall (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE            :: tt_surface_window_m !< surface temperature tendency of window (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE            :: tt_surface_green_m !< surface temperature tendency of green wall (K)
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -738,33 +1086,62 @@
 #if defined( __nopointer )
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_wall_h             !< Wall temperature (K)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_wall_h_av          !< Average of t_wall
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_wall_h_p           !< Prog. wall temperature (K)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_window_h           !< Window temperature (K)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_window_h_av        !< Average of t_window
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_window_h_p         !< Prog. window temperature (K)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_green_h            !< Green temperature (K)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_green_h_av         !< Average of t_green
     REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_green_h_p          !< Prog. green temperature (K)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: swc_h              !< soil water content green building layer
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: swc_h_av              !< avg of soil water content green building layer
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: swc_h_p              !< Prog. soil water content green building layer
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: swc_sat_h          !< soil water content green building layer at saturation
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: swc_res_h          !< soil water content green building layer residual
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: rootfr_h           !< root fraction green green building layer
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: wilt_h             !< wilting point green building layer
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: fc_h               !< field capacity green building layer
+
 
     TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_wall_v             !< Wall temperature (K)
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_wall_v_av          !< Average of t_wall
     TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_wall_v_p           !< Prog. wall temperature (K)
     TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_window_v           !< Window temperature (K)
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_window_v_av        !< Average of t_window
     TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_window_v_p         !< Prog. window temperature (K)
     TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_green_v            !< Green temperature (K)
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_green_v_av         !< Average of t_green
     TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_green_v_p          !< Prog. green temperature (K)
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: swc_v             !< Wall swc
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: swc_v_av          !< Average of swc
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: swc_v_p           !< Prog. swc
+    
 #else
     REAL(wp), DIMENSION(:,:), POINTER                :: t_wall_h, t_wall_h_p
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_wall_h_1, t_wall_h_2
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_wall_h_av, t_wall_h_1, t_wall_h_2
     REAL(wp), DIMENSION(:,:), POINTER                :: t_window_h, t_window_h_p
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_window_h_1, t_window_h_2
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_window_h_av, t_window_h_1, t_window_h_2
     REAL(wp), DIMENSION(:,:), POINTER                :: t_green_h, t_green_h_p
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_green_h_1, t_green_h_2
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_green_h_av, t_green_h_1, t_green_h_2
+    REAL(wp), DIMENSION(:,:), POINTER                :: swc_h, rootfr_h, wilt_h, fc_h, swc_sat_h, swc_h_p, swc_res_h
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: swc_h_1, rootfr_h_1, &
+                                                        wilt_h_1, fc_h_1, swc_sat_h_1, swc_h_2, swc_res_h_1
+    
 
     TYPE(t_wall_vertical), DIMENSION(:), POINTER   :: t_wall_v, t_wall_v_p
-    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_wall_v_1, t_wall_v_2
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_wall_v_av, t_wall_v_1, t_wall_v_2
     TYPE(t_wall_vertical), DIMENSION(:), POINTER   :: t_window_v, t_window_v_p
-    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_window_v_1, t_window_v_2
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_window_v_av, t_window_v_1, t_window_v_2
     TYPE(t_wall_vertical), DIMENSION(:), POINTER   :: t_green_v, t_green_v_p
-    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_green_v_1, t_green_v_2
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_green_v_av, t_green_v_1, t_green_v_2
+    TYPE(t_wall_vertical), DIMENSION(:), POINTER   :: swc_v, swc_v_p
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: swc_v_av, swc_v_1, swc_v_2
 #endif
 
-!
+!-- Wall temporal tendencies for time stepping
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: tt_wall_m          !< t_wall prognostic array 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: tt_window_m        !< t_window prognostic array 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: tt_green_m         !< t_green prognostic array 
+
 !-- Surface and material parameters classes (surface_type)
 !-- albedo, emissivity, lambda_surf, roughness, thickness, volumetric heat capacity, thermal conductivity
@@ -864,6 +1241,6 @@
 
 !-- Public parameters, constants and initial values
-    PUBLIC usm_anthropogenic_heat, usm_material_model,                          &
-           usm_green_heat_model, usm_temperature_near_surface
+    PUBLIC usm_anthropogenic_heat, usm_material_model, usm_wall_mod,           &
+           usm_green_heat_model, usm_temperature_near_surface, building_pars
 
 
@@ -949,18 +1326,19 @@
        
 !--     wall and roof surface parameters. First for horizontal surfaces
-        ALLOCATE ( surf_usm_h%isroof_surf(1:surf_usm_h%ns)     )
-        ALLOCATE ( surf_usm_h%lambda_surf(1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%isroof_surf(1:surf_usm_h%ns)        )
+        ALLOCATE ( surf_usm_h%lambda_surf(1:surf_usm_h%ns)        )
         ALLOCATE ( surf_usm_h%lambda_surf_window(1:surf_usm_h%ns) )
         ALLOCATE ( surf_usm_h%lambda_surf_green(1:surf_usm_h%ns)  )
-        ALLOCATE ( surf_usm_h%c_surface(1:surf_usm_h%ns)       )
+        ALLOCATE ( surf_usm_h%c_surface(1:surf_usm_h%ns)          )
         ALLOCATE ( surf_usm_h%c_surface_window(1:surf_usm_h%ns)   )
         ALLOCATE ( surf_usm_h%c_surface_green(1:surf_usm_h%ns)    )
-        ALLOCATE ( surf_usm_h%transmissivity(1:surf_usm_h%ns)  )
-        ALLOCATE ( surf_usm_h%lai(1:surf_usm_h%ns)             )
-        ALLOCATE ( surf_usm_h%emissivity(0:2,1:surf_usm_h%ns)  )
-        ALLOCATE ( surf_usm_h%r_a(1:surf_usm_h%ns)             )
-        ALLOCATE ( surf_usm_h%r_a_green(1:surf_usm_h%ns)       )
-        ALLOCATE ( surf_usm_h%r_a_window(1:surf_usm_h%ns)      )
-
+        ALLOCATE ( surf_usm_h%transmissivity(1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%lai(1:surf_usm_h%ns)                )
+        ALLOCATE ( surf_usm_h%emissivity(0:2,1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%r_a(1:surf_usm_h%ns)                )
+        ALLOCATE ( surf_usm_h%r_a_green(1:surf_usm_h%ns)          )
+        ALLOCATE ( surf_usm_h%r_a_window(1:surf_usm_h%ns)         )
+        ALLOCATE ( surf_usm_h%green_type_roof(1:surf_usm_h%ns)    )
+        ALLOCATE ( surf_usm_h%r_s(1:surf_usm_h%ns)                )
 !
 !--     For vertical surfaces.
@@ -978,4 +1356,6 @@
            ALLOCATE ( surf_usm_v(l)%r_a_green(1:surf_usm_v(l)%ns)       )
            ALLOCATE ( surf_usm_v(l)%r_a_window(1:surf_usm_v(l)%ns)      )
+           
+          ALLOCATE ( surf_usm_v(l)%r_s(1:surf_usm_v(l)%ns)                 )
         ENDDO
 
@@ -991,4 +1371,13 @@
         ALLOCATE ( surf_usm_h%lambda_h_green(nzb_wall:nzt_wall,1:surf_usm_h%ns)  )
         ALLOCATE ( surf_usm_h%rho_c_green(nzb_wall:nzt_wall,1:surf_usm_h%ns)     )
+
+        ALLOCATE ( surf_usm_h%rho_c_total_green(nzb_wall:nzt_wall,1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%n_vg_green(1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%alpha_vg_green(1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%l_vg_green(1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%gamma_w_green_sat(nzb_wall:nzt_wall,1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%lambda_w_green(nzb_wall:nzt_wall,1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%gamma_w_green(nzb_wall:nzt_wall,1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%tswc_h_m(nzb_wall:nzt_wall,1:surf_usm_h%ns)     )
 
 !
@@ -1006,4 +1395,26 @@
         ENDDO
 
+!
+!--     allocate green wall and roof vegetation and soil parameters. First horizontal surfaces
+        ALLOCATE ( surf_usm_h%g_d(1:surf_usm_h%ns)              )
+        ALLOCATE ( surf_usm_h%c_liq(1:surf_usm_h%ns)            )
+        ALLOCATE ( surf_usm_h%qsws_liq_eb(1:surf_usm_h%ns)         )
+        ALLOCATE ( surf_usm_h%qsws_veg_eb(1:surf_usm_h%ns)         )
+        ALLOCATE ( surf_usm_h%r_canopy(1:surf_usm_h%ns)         )
+        ALLOCATE ( surf_usm_h%r_canopy_min(1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%qsws_eb(1:surf_usm_h%ns)         )
+
+!
+!--     For vertical surfaces.
+        DO  l = 0, 3
+          ALLOCATE ( surf_usm_v(l)%g_d(1:surf_usm_v(l)%ns)              )
+          ALLOCATE ( surf_usm_v(l)%c_liq(1:surf_usm_v(l)%ns)            )
+          ALLOCATE ( surf_usm_v(l)%qsws_liq_eb(1:surf_usm_v(l)%ns)         )
+          ALLOCATE ( surf_usm_v(l)%qsws_veg_eb(1:surf_usm_v(l)%ns)         )
+          ALLOCATE ( surf_usm_v(l)%qsws_eb(1:surf_usm_v(l)%ns)          )
+          ALLOCATE ( surf_usm_v(l)%r_canopy(1:surf_usm_v(l)%ns)         )
+          ALLOCATE ( surf_usm_v(l)%r_canopy_min(1:surf_usm_v(l)%ns)     )
+        ENDDO
+        
 !--     allocate wall and roof layers sizes. For horizontal surfaces.
         ALLOCATE ( zwn(nzb_wall:nzt_wall) )
@@ -1047,8 +1458,8 @@
 !--     allocate wall and roof temperature arrays, for horizontal walls
 #if defined( __nopointer )
-        IF ( .NOT. ALLOCATED( t_surf_h ) )                                     &
-           ALLOCATE ( t_surf_h(1:surf_usm_h%ns) )
-        IF ( .NOT. ALLOCATED( t_surf_h_p ) )                                   &
-           ALLOCATE ( t_surf_h_p(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_surf_wall_h ) )                                     &
+           ALLOCATE ( t_surf_wall_h(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_surf_wall_h_p ) )                                   &
+           ALLOCATE ( t_surf_wall_h_p(1:surf_usm_h%ns) )
         IF ( .NOT. ALLOCATED( t_wall_h ) )                                     &           
            ALLOCATE ( t_wall_h(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) ) 
@@ -1075,12 +1486,36 @@
         IF ( .NOT. ALLOCATED( t_surf_10cm_h_p ) )                              &
            ALLOCATE ( t_surf_10cm_h_p(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( swc_h ) )                                    &           
+           ALLOCATE ( swc_h(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( swc_sat_h ) )                                    &           
+           ALLOCATE ( swc_sat_h(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( swc_res_h ) )                                    &           
+           ALLOCATE ( swc_res_h(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( rootfr_h ) )                                    &           
+           ALLOCATE ( rootfr_h(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( wilt_h ) )                                    &           
+           ALLOCATE ( wilt_h(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( fc_h ) )                                    &           
+           ALLOCATE ( fc_h(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) ) 
+
+       IF ( .NOT. ALLOCATED( m_liq_usm_h%var_usm_1d ) )                            &
+          ALLOCATE ( m_liq_usm_h%var_usm_1d(1:surf_usm_h%ns) )
+
+!--    Horizontal surfaces
+       ALLOCATE ( m_liq_usm_h_p%var_usm_1d(1:surf_usm_h%ns)                      )
+!
+!--    Vertical surfaces
+       DO  l = 0, 3
+          ALLOCATE ( m_liq_usm_v_p(l)%var_usm_1d(1:surf_usm_v(l)%ns)                      )
+       ENDDO
+          
 #else
 !
 !--     Allocate if required. Note, in case of restarts, some of these arrays 
 !--     might be already allocated.
-        IF ( .NOT. ALLOCATED( t_surf_h_1 ) )                                   &
-           ALLOCATE ( t_surf_h_1(1:surf_usm_h%ns) )
-        IF ( .NOT. ALLOCATED( t_surf_h_2 ) )                                   &
-           ALLOCATE ( t_surf_h_2(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_surf_wall_h_1 ) )                                   &
+           ALLOCATE ( t_surf_wall_h_1(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_surf_wall_h_2 ) )                                   &
+           ALLOCATE ( t_surf_wall_h_2(1:surf_usm_h%ns) )
         IF ( .NOT. ALLOCATED( t_wall_h_1 ) )                                   &           
            ALLOCATE ( t_wall_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) ) 
@@ -1107,4 +1542,24 @@
         IF ( .NOT. ALLOCATED( t_surf_10cm_h_2 ) )                              &
            ALLOCATE ( t_surf_10cm_h_2(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( swc_h_1 ) )                                  &           
+           ALLOCATE ( swc_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) ) 
+        IF ( .NOT. ALLOCATED( swc_sat_h_1 ) )                                  &           
+           ALLOCATE ( swc_sat_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) ) 
+        IF ( .NOT. ALLOCATED( swc_res_h_1 ) )                                  &           
+           ALLOCATE ( swc_res_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) ) 
+        IF ( .NOT. ALLOCATED( swc_h_2 ) )                                  &           
+           ALLOCATE ( swc_h_2(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( rootfr_h_1 ) )                                  &           
+           ALLOCATE ( rootfr_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) ) 
+        IF ( .NOT. ALLOCATED( wilt_h_1 ) )                                  &           
+           ALLOCATE ( wilt_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) ) 
+        IF ( .NOT. ALLOCATED( fc_h_1 ) )                                  &           
+           ALLOCATE ( fc_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) ) 
+
+        IF ( .NOT. ALLOCATED( m_liq_usm_h_1%var_usm_1d ) )                         &
+           ALLOCATE ( m_liq_usm_h_1%var_usm_1d(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( m_liq_usm_h_2%var_usm_1d ) )                         &
+           ALLOCATE ( m_liq_usm_h_2%var_usm_1d(1:surf_usm_h%ns) )
+           
 !           
 !--     initial assignment of the pointers
@@ -1112,8 +1567,15 @@
         t_window_h    => t_window_h_1;    t_window_h_p    => t_window_h_2
         t_green_h    => t_green_h_1;    t_green_h_p    => t_green_h_2
-        t_surf_h => t_surf_h_1; t_surf_h_p => t_surf_h_2           
+        t_surf_wall_h => t_surf_wall_h_1; t_surf_wall_h_p => t_surf_wall_h_2           
         t_surf_window_h => t_surf_window_h_1; t_surf_window_h_p => t_surf_window_h_2  
         t_surf_green_h => t_surf_green_h_1; t_surf_green_h_p => t_surf_green_h_2           
         t_surf_10cm_h => t_surf_10cm_h_1; t_surf_10cm_h_p => t_surf_10cm_h_2  
+        m_liq_usm_h     => m_liq_usm_h_1;     m_liq_usm_h_p     => m_liq_usm_h_2
+        swc_h       => swc_h_1; swc_h_p     => swc_h_2
+        swc_sat_h    => swc_sat_h_1
+        swc_res_h    => swc_res_h_1
+        rootfr_h       => rootfr_h_1
+        wilt_h       => wilt_h_1
+        fc_h       => fc_h_1
  
 #endif
@@ -1122,8 +1584,8 @@
 #if defined( __nopointer )
         DO  l = 0, 3
-           IF ( .NOT. ALLOCATED( t_surf_v(l)%t ) )                             &
-              ALLOCATE ( t_surf_v(l)%t(1:surf_usm_v(l)%ns) )
-           IF ( .NOT. ALLOCATED( t_surf_v_p(l)%t ) )                           &
-              ALLOCATE ( t_surf_v_p(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_wall_v(l)%t ) )                             &
+              ALLOCATE ( t_surf_wall_v(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_wall_v_p(l)%t ) )                           &
+              ALLOCATE ( t_surf_wall_v_p(l)%t(1:surf_usm_v(l)%ns) )
            IF ( .NOT. ALLOCATED( t_wall_v(l)%t ) )                             &
               ALLOCATE ( t_wall_v(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
@@ -1150,4 +1612,10 @@
            IF ( .NOT. ALLOCATED( t_surf_10cm_v_p(l)%t ) )                        &
               ALLOCATE ( t_surf_10cm_v_p(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( m_liq_usm_v(l)%var_usm_1d ) )                 &
+             ALLOCATE ( m_liq_usm_v(l)%var_usm_1d(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( swc_v(l)%t ) )                             &
+              ALLOCATE ( swc_v(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( swc_v_p(l)%t ) )                           &                 
+              ALLOCATE ( swc_v_p(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
         ENDDO
 #else
@@ -1156,8 +1624,8 @@
 !--     might be already allocated.
         DO  l = 0, 3
-           IF ( .NOT. ALLOCATED( t_surf_v_1(l)%t ) )                           &
-              ALLOCATE ( t_surf_v_1(l)%t(1:surf_usm_v(l)%ns) )
-           IF ( .NOT. ALLOCATED( t_surf_v_2(l)%t ) )                           &
-              ALLOCATE ( t_surf_v_2(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_wall_v_1(l)%t ) )                           &
+              ALLOCATE ( t_surf_wall_v_1(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_wall_v_2(l)%t ) )                           &
+              ALLOCATE ( t_surf_wall_v_2(l)%t(1:surf_usm_v(l)%ns) )
            IF ( .NOT. ALLOCATED( t_wall_v_1(l)%t ) )                           &           
               ALLOCATE ( t_wall_v_1(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) ) 
@@ -1184,9 +1652,17 @@
            IF ( .NOT. ALLOCATED( t_surf_10cm_v_2(l)%t ) )                     &
               ALLOCATE ( t_surf_10cm_v_2(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( m_liq_usm_v_1(l)%var_usm_1d ) )              &
+              ALLOCATE ( m_liq_usm_v_1(l)%var_usm_1d(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( m_liq_usm_v_2(l)%var_usm_1d ) )              &
+              ALLOCATE ( m_liq_usm_v_2(l)%var_usm_1d(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( swc_v_1(l)%t ) )                           &           
+              ALLOCATE ( swc_v_1(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) ) 
+           IF ( .NOT. ALLOCATED( swc_v_2(l)%t ) )                           &           
+              ALLOCATE ( swc_v_2(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )  
         ENDDO
 !
 !--     initial assignment of the pointers
         t_wall_v    => t_wall_v_1;    t_wall_v_p    => t_wall_v_2
-        t_surf_v => t_surf_v_1; t_surf_v_p => t_surf_v_2
+        t_surf_wall_v => t_surf_wall_v_1; t_surf_wall_v_p => t_surf_wall_v_2
         t_window_v    => t_window_v_1;    t_window_v_p    => t_window_v_2
         t_green_v    => t_green_v_1;    t_green_v_p    => t_green_v_2
@@ -1194,9 +1670,11 @@
         t_surf_green_v => t_surf_green_v_1; t_surf_green_v_p => t_surf_green_v_2
         t_surf_10cm_v => t_surf_10cm_v_1; t_surf_10cm_v_p => t_surf_10cm_v_2
+        m_liq_usm_v     => m_liq_usm_v_1;     m_liq_usm_v_p     => m_liq_usm_v_2
+        swc_v    => swc_v_1;    swc_v_p    => swc_v_2
 
 #endif
 !
 !--     Allocate intermediate timestep arrays. For horizontal surfaces.
-        ALLOCATE ( surf_usm_h%tt_surface_m(1:surf_usm_h%ns)                  )
+        ALLOCATE ( surf_usm_h%tt_surface_wall_m(1:surf_usm_h%ns)                  )
         ALLOCATE ( surf_usm_h%tt_wall_m(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
         ALLOCATE ( surf_usm_h%tt_surface_window_m(1:surf_usm_h%ns)             )
@@ -1206,6 +1684,16 @@
 
 !
+!--    Allocate intermediate timestep arrays
+!--    Horizontal surfaces
+       ALLOCATE ( tm_liq_usm_h_m%var_usm_1d(1:surf_usm_h%ns)                   )
+!
+!--    Horizontal surfaces
+       DO  l = 0, 3
+          ALLOCATE ( tm_liq_usm_v_m(l)%var_usm_1d(1:surf_usm_v(l)%ns)          )
+       ENDDO 
+        
+!
 !--     Set inital values for prognostic quantities
-        IF ( ALLOCATED( surf_usm_h%tt_surface_m ) )  surf_usm_h%tt_surface_m = 0.0_wp
+        IF ( ALLOCATED( surf_usm_h%tt_surface_wall_m ) )  surf_usm_h%tt_surface_wall_m = 0.0_wp
         IF ( ALLOCATED( surf_usm_h%tt_wall_m    ) )  surf_usm_h%tt_wall_m    = 0.0_wp
         IF ( ALLOCATED( surf_usm_h%tt_surface_window_m ) )  surf_usm_h%tt_surface_window_m = 0.0_wp
@@ -1216,7 +1704,7 @@
 !--     Now, for vertical surfaces
         DO  l = 0, 3
-           ALLOCATE ( surf_usm_v(l)%tt_surface_m(1:surf_usm_v(l)%ns)                  )
+           ALLOCATE ( surf_usm_v(l)%tt_surface_wall_m(1:surf_usm_v(l)%ns)                  )
            ALLOCATE ( surf_usm_v(l)%tt_wall_m(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
-           IF ( ALLOCATED( surf_usm_v(l)%tt_surface_m ) )  surf_usm_v(l)%tt_surface_m = 0.0_wp
+           IF ( ALLOCATED( surf_usm_v(l)%tt_surface_wall_m ) )  surf_usm_v(l)%tt_surface_wall_m = 0.0_wp
            IF ( ALLOCATED( surf_usm_v(l)%tt_wall_m    ) )  surf_usm_v(l)%tt_wall_m    = 0.0_wp
            ALLOCATE ( surf_usm_v(l)%tt_surface_window_m(1:surf_usm_v(l)%ns)             )
@@ -1334,4 +1822,14 @@
             ELSE
 !--             wrong green layer index
+                RETURN
+            ENDIF
+        ENDIF
+        IF ( var(1:8) == 'usm_swc_'  .AND.  len(TRIM(var)) >= 9 )  THEN
+!--          swc layers
+            READ(var(9:9), '(I1)', iostat=istat ) iwl
+            IF ( istat == 0  .AND.  iwl >= nzb_wall  .AND.  iwl <= nzt_wall )  THEN
+                var = var(1:7)
+            ELSE
+!--             wrong swc layer index
                 RETURN
             ENDIF
